//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 LimeGreen
#property indicator_color2 LimeGreen
#property indicator_color3 LimeGreen
#property indicator_color4 Gray
#property indicator_color5 Red
#property indicator_color6 Red
#property indicator_color7 Red
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT
#property indicator_style4 STYLE_DOT
#property indicator_style5 STYLE_DOT
#property indicator_style6 STYLE_DOT
#property indicator_style7 STYLE_DOT

extern string TimeFrame   = "Current time frame";
extern int    RangePeriod = 20;

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];

int timeFrame;

//--------------------------------------------------------
//
//--------------------------------------------------------
int init()
{
   SetIndexBuffer (0,buffer1); 
   SetIndexBuffer (1,buffer2); 
   SetIndexBuffer (2,buffer3);
   SetIndexBuffer (3,buffer4);
   SetIndexBuffer (4,buffer5);
   SetIndexBuffer (5,buffer6);
   SetIndexBuffer (6,buffer7);
      timeFrame = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit() { return(0); }

//--------------------------------------------------------
//
//--------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
               limit = MathMin(Bars-1,MathMax(limit,iBarShift(NULL,0,iTime(NULL,timeFrame,1))));

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      int    y     = iBarShift(NULL,timeFrame,Time[i]);
      double range = iHigh(NULL,timeFrame,y)-iLow(NULL,timeFrame,y);
         for (int k=1; k<RangePeriod; k++) range += iHigh(NULL,timeFrame,y+k)-iLow(NULL,timeFrame,y+k);
                                           range /= RangePeriod;
         buffer4[i] = iOpen(NULL,timeFrame,y);
         buffer1[i] = buffer4[i]+3.0*range;
         buffer2[i] = buffer4[i]+2.0*range;
         buffer3[i] = buffer4[i]+1.0*range;
         buffer5[i] = buffer4[i]-1.0*range;
         buffer6[i] = buffer4[i]-2.0*range;
         buffer7[i] = buffer4[i]-3.0*range;
   }
   return(0);
}  

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}